<template>
  <div class="filters-group ds">
    <!-- DESKTOP Version -->
    <!-- <div class="d-none d-md-block"> (Disabled for the first release on ppe2) -->
    <div class="">
      <div class="row margin-0-mobile px-4 py-2  p-md-0 blueBG-mobile">
        <div class="col padding-0-mobile">
          <div class="input-group flex-column-reverse flex-md-row">

            <!-- #Start# Mobile version searchbutton -->
            <div class="input-group-append ec-ds-search-button-container d-flex mt-3 d-md-none">
              <button class="
                  btn btn-sm btn-primary
                  d-flex
                  justify-content-center
                  align-items-center
                  ds-input
                  ec-ds-search-btn
                  w-100
                " type="button" @click="changeQuery(query)">
                <span>{{ $t('message.datasets.ecd.filters.search') }}</span>
                <i class="material-icons align-bottom ml-1">search</i>
              </button>
            </div>

            <!-- #End# Mobile version searchbutton -->

            <div class="form-control rounded-lg ds-input ec-ds-search mt-3 mt-md-0">
              <input type="text" class="form-control" :aria-label="$t('message.datasets.searchBar.placeholder')"
                :placeholder="$t('message.datasets.searchBar.placeholder')" v-model="query"
                @keyup="autocompleteSuggestions()" @keyup.enter="changeQuery(query)" @click="
                  showSuggestions.active = true,
                  query = ''
                  // autocompleteData.show =
                  // autocompleteData.suggestions.length > 0 && query.length > 0
                  //   ? !autocompleteData.show
                  //   : false
                  ">
              <ul ref="dropdownSuggestions" v-if="showSuggestions.active" type="text" class="suggestedTitlesWrapper">

                <li v-if="isLoadingSuggestions" v-for="i in 2" class="loadingField">load</li>

                <li v-else v-for="title in suggestedTitles" @click="query = title; changeQuery(query)">
                <div class="row g-2">
                  <div class="col-1 auto-thumbnail">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-file-earmark" viewBox="0 0 16 16">
                    <path d="M14 4.5V14a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h5.5zm-3 0A1.5 1.5 0 0 1 9.5 3V1H4a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h8a1 1 0 0 0 1-1V4.5z"/>
                  </svg>
                  </div>
                  <div class="col-10">
                    <div class="auto-title">
                      <span v-for="(part, index) in splitTitle(title)" :key="index">
                        <b v-if="part.isMatch">{{ part.text }}</b>
                        <span v-else>{{ part.text }}</span>
                      </span>
                      <!-- <span>(2020)</span> -->
                    </div>
                    <div class="auto-type">Dataset</div>
                  </div>
                </div>
              </li>
              </ul>
              <app-link :to="`https://dataeuropa.gitlab.io/data-provider-manual/how-to-search/search-for-datasets/`" target="_blank">
                <i class="tooltip-icon material-icons small-icon align-right absolute text-dark pl-1"
                  data-placement="right">
                  help_outline
                </i>
              </app-link>

            </div>



            <div class="d-flex cursor-pointer">
              <!-- TABLIST to Dropdown -->
              <div class="btn-group ec-ds-scope-dropdown ds-input" role="group">
                <button class="
                    value-display
                    list-group-item
                    col
                    w-100
                    d-flex
                    flex-row
                    justify-content-between
                    p-0
                    align-items-center
                    ec-ds-scope-dropdown-inlay
                  " id="btnGroupDrop2" type="button" data-toggle="dropdown" aria-expanded="false">
                  <div class="
                      pl-2
                      h-100
                      d-flex
                      ds-input
                      align-items-center
                      font-weight-bold
                      ec-ds-scope-text
                    ">
                    <!-- {{ sortSelectedLabel }} -->
                    {{ $t("message.header.navigation.data.datasets") }}
                  </div>
                  <div class="ecl-select__icon ec-ds-scope-select">
                    <svg class="
                        ecl-icon ecl-icon--s ecl-icon--rotate-180
                        ecl-select__icon-shape
                        ec-ds-scope-arrow
                      " focusable="false" aria-hidden="true">
                      <use xlink:href="../assets/img/ecl/icons.svg#corner-arrow"></use>
                    </svg>
                  </div>
                </button>
                <ul class="dropdown-menu ec-ds-dropdown-items" aria-labelledby="btnGroupDrop2">
                  <!-- <li class="nav-item mb-0" role="tab"
                  :title="$t('message.tooltip.datasets')"
                  data-toggle="tooltip"
                  data-placement="top"> -->
                  <li class="nav-item mb-0" role="tab">
                    <router-link :to="{
                      name: 'Datasets',
                      query: { locale: $route.query.locale },
                    }" class="nav-link router-link-active" role="presentation">
                      {{ $t("message.header.navigation.data.datasets") }}
                    </router-link>
                  </li>
                  <!-- <li class="nav-item mb-0" role="tab"
                :title="$t('message.tooltip.catalogues')"
                data-toggle="tooltip"
                data-placement="top"> -->
                  <li class="nav-item mb-0" role="tab">

                    <router-link :to="{
                      name: 'Catalogues',
                      query: catalogueRouteQuery(),
                    }" v-if="useCatalogs" class="nav-link router-link-inactive" role="presentation">
                      {{ $t("message.header.navigation.data.catalogs") }}
                    </router-link>
                  </li>
                  <li class="nav-item mb-0" role="tab">
                    <!-- <a
                :href="`/${this.$route.query.locale}/search?term=${query}&searchdomain=site`"
                class="nav-link router-link-inactive"
                role="presentation"
                :title="$t('message.tooltip.editorialContent')"
                data-toggle="tooltip"
                data-placement="top">
                {{ $t('message.searchTabs.editorialContent') }}
              </a> -->
                    <a :href="`/${this.$route.query.locale}/search?term=${query}&searchdomain=site`"
                      class="nav-link router-link-inactive" role="presentation">
                      {{ $t("message.searchTabs.editorialContent") }}
                    </a>
                  </li>
                </ul>
              </div>
              <!-- <ul class="d-flex justify-content-between flex-wrap-reverse nav nav-tabs" id="myTab" role="tablist">
            <li class="nav-item mb-0" role="tab"
                  :title="$t('message.tooltip.datasets')"
                  data-toggle="tooltip"
                  data-placement="top">
                <router-link
                  :to="{name: 'Datasets', query: { locale: $route.query.locale }}"
                  class="nav-link router-link-active"
                  role="presentation">
                     {{ $t('message.header.navigation.data.datasets') }}
                </router-link>
            </li>
            <li class="nav-item mb-0" role="tab"
                :title="$t('message.tooltip.catalogues')"
                data-toggle="tooltip"
                data-placement="top">
              <router-link
                :to="{name: 'Catalogues', query: { locale: $route.query.locale }}"
                v-if="useCatalogs"
                class="nav-link router-link-inactive"
                role="presentation">
                {{ $t('message.header.navigation.data.catalogs') }}
              </router-link>
            </li>
            <li class="nav-item mb-0" role="tab">
              <a
                :href="`/${this.$route.query.locale}/search?term=${query}&searchdomain=site`"
                class="nav-link router-link-inactive"
                role="presentation"
                :title="$t('message.tooltip.editorialContent')"
                data-toggle="tooltip"
                data-placement="top">
                {{ $t('message.searchTabs.editorialContent') }}
              </a>
            </li>
            </ul> -->
            </div>
            <div class="input-group-append ec-ds-search-button-container d-none d-md-flex">
              <button class="
                  btn btn-sm btn-primary
                  d-flex
                  align-items-center
                  ds-input
                  ec-ds-search-btn
                " type="button" @click="changeQuery(query)">
                <i class="material-icons align-bottom ml-1">search</i>
              </button>
            </div>
            <div class="suggestion-list-group" v-if="autocompleteData.show">
              <ul class="list-group suggestion-list">
                <button class="list-group-item list-group-item-action"
                  v-for="suggestion in autocompleteData.suggestions" :key="suggestion.id"
                  @click="handleSuggestionSelection(suggestion)">
                  {{
                    getTranslationFor(
                      suggestion.title,
                      $route.query.locale,
                      suggestion.languages
                    )
                  }}
                </button>
              </ul>
            </div>
          </div>
        </div>
      </div>
       <!-- ADVANCED SEARCH BUTTON -->
       <div clsss="advanced-btn-container">
           <button class="ecl-button ecl-button--primary advanced-btn" @click="openAdvanced()">  
            <span v-if="advancedQuery || advancedType || advancedFilters" class="badge advanced-badge">x</span> <!-- get number from all set parameters from the store-->
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sliders"
                viewBox="0 0 16 16">
                <path fill-rule="evenodd"
                  d="M11.5 2a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3M9.05 3a2.5 2.5 0 0 1 4.9 0H16v1h-2.05a2.5 2.5 0 0 1-4.9 0H0V3zM4.5 7a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3M2.05 8a2.5 2.5 0 0 1 4.9 0H16v1H6.95a2.5 2.5 0 0 1-4.9 0H0V8zm9.45 4a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3m-2.45 1a2.5 2.5 0 0 1 4.9 0H16v1h-2.05a2.5 2.5 0 0 1-4.9 0H0v-1z" />
              </svg>
              Advanced Search
            </button>
          </div>

      <!-- Search Result coloumn -->
      <div class="ec-search-result">
        <div class="row margin-0-mobile flex-column flex-md-row ">
          <!-- Headline & Count  -->
          <div class="ds-result-headline padding-0-mobile col">
            {{
              getLoading
                ? $t("message.datasets.loadingMessage")
                : `${$t("message.datasets.countMessage")}
            (${getDatasetsCount.toLocaleString("fi")})`
            }}
          </div>

          <!-- API button Simple -->
          <div>
            <button @click="openApiRequest()" class="mt-4 mr-5 api-custom">API request
              <svg data-v-e7b11991="" data-v-363c04b8="" width="16" height="16" viewBox="0 0 48 48"
                xmlns="http://www.w3.org/2000/svg" class="access-link-icon">
                <path data-v-e7b11991=""
                  d="M14 2v4H6v36h36v-8h4v12H2V2h12Zm32 0v20h-4V8.667l-.201.404-16.97 16.97L22 23.214l16.97-16.97.484-.243H26V2h20Z">
                </path>
              </svg>
            </button>
          </div>
          <!-- SORT Dropdown  -->
          <div class="ec-sort mr-md-2 mt-0 mt-md-3 ">
            <div class="d-inline align-middle colorPrimarySort font-weight-bold mr-2">Sort by:</div>
            <div class="col-right mr-md-2 d-inline" role="group" aria-label="Sort Dropdown">
              <div class="btn-group ec-sort-dropdown" role="group">
                <button class="
                  colorPrimarySort
                    value-display
                    list-group-item
                    col
                    w-100
                    d-flex
                    flex-row
                    justify-content-md-between
                    p-0
                    align-items-center
                  " id="btnGroupDrop1" type="button" data-toggle="dropdown" aria-expanded="false">
                  <div class="pl-2 h-100 d-flex align-items-center">
                    {{ sortSelectedLabel }}
                  </div>
                  <div class="ecl-select__icon ecl-select__icon-Sort">
                    <svg class="
                        ecl-icon ecl-icon--s ecl-icon--rotate-180
                        ecl-select__icon-shape
                      " focusable="false" aria-hidden="true">
                      <use xlink:href="../assets/img/ecl/icons.svg#corner-arrow"></use>
                    </svg>
                  </div>
                </button>
                <ul class="dropdown-menu ec-ds-dropdown-items" aria-labelledby="btnGroupDrop1">
                  <button class="dropdown-item" @click="
                    setSortMethod(
                      'modified',
                      'desc',
                      $t('message.sort.lastModified')
                    )
                    ">
                    {{ $t("message.sort.lastUpdated") }}
                  </button>
                  <button class="dropdown-item" @click="
                    setSortMethod(
                      'relevance',
                      'desc',
                      $t('message.sort.relevance')
                    )
                    ">
                    {{ $t("message.sort.relevance") }}
                  </button>
                  <button class="dropdown-item" @click="
                    setSortMethod(
                      `title.${$route.query.locale}`,
                      'asc',
                      $t('message.sort.nameAZ')
                    )
                    ">
                    {{ $t("message.sort.nameAZ") }}
                  </button>
                  <button class="dropdown-item" @click="
                    setSortMethod(
                      `title.${$route.query.locale}`,
                      'desc',
                      $t('message.sort.nameZA')
                    )
                    ">
                    {{ $t("message.sort.nameZA") }}
                  </button>
                  <button class="dropdown-item" @click="
                    setSortMethod(
                      'issued',
                      'desc',
                      $t('message.sort.lastCreated')
                    )
                    ">
                    {{ $t("message.sort.lastCreated") }}
                  </button>
                </ul>
              </div>
            </div>
          </div>
        </div>
        <hr class="d-none d-md-block" />
      </div>
    </div>
    <!-- Mobile Version (Disabled for the first PPE2 release) -->
    <!-- <div class="d-block d-md-none">
      [Mobile Search here]
    </div> -->
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import { helpers, AppLink } from "@piveau/piveau-hub-ui-modules";
const { getTranslationFor } = helpers;
import { onClickOutside } from '@vueuse/core'
import { ref, reactive } from 'vue'

export default {
  name: "ECDatasetsFilters",
  data() {
    return {
      baseUrl: this.$env.api.baseUrl,
      query: "",
      scope: 'dataset',
      UrlQuery: '',
      encodedFacets: [],
      includes: `id,title.${this.$route.query.locale},description.${this.$route.query.locale},languages,modified,issued,catalog.id,catalog.title,catalog.country.id,distributions.id,distributions.format.label,distributions.format.id,distributions.license,categories.label,publisher`,
      suggestedTitles: [],
      isLoadingSuggestions: false,
      lastKeyup: null,
      autocompleteData: {
        suggestions: {},
        show: true,
      },
      useCatalogs: this.$env.content.datasets.useCatalogs,
      sortSelected: "",
      sortSelectedLabel: this.$t("message.sort.relevance"),
      advancedQuery: sessionStorage.getItem('query') || '',
      advancedType: sessionStorage.getItem('selectedOption') || '',
      advancedFilter: sessionStorage.getItem('selectedFields') || ''   
    };
  },
  components: {
    AppLink
  },
  computed: {
    ...mapGetters("datasets", ["getDatasetsCount", "getLoading", "getFacets"]),

  },
  methods: {
    openAdvanced() {
      this.$router.push({ name: 'AdvancedSearch' });
    },
    getTranslationFor,
    ...mapActions("datasets", ["setQuery", "autocompleteQuery", "setSort"]),
    /**
     * @description Initialize the query String by checking the route parameters
     */
    initQuery() {
      let query = this.$route.query.query;
      if (!query) {
        query = "";
        this.setQuery("");
      } else {
        this.query = query;
        this.setQuery(query);
      }
    },
    async autocompleteSuggestions() {
      this.isLoadingSuggestions = true
      // only the last keyup gets recognized -- improves performance!
      clearTimeout(this.lastKeyup)
      this.lastKeyup = setTimeout(async () => {


        let endpoint = this.baseUrl;
        let language = this.$route.query.locale;
        let autocompleteRequest = endpoint + "/search" + "?q=" + this.query + "&filters=" + this.scope +
          "&autocomplete=true" +
          "&includes=title." + language + ",description." + language + ",keywords"
        "&limit=10";


        try {
          const response = await fetch(autocompleteRequest);
          const data = await response.json();
          const results = data.result.results;
          this.suggestedTitles = results[0]['titles']
        } catch (error) {
          console.log(error)
        }
        this.isLoadingSuggestions = false
      }, 500);


    },
    splitTitle(title) {
      const escapedQuery = this.query.replace(/[-/\\^$*+?.()|[\]{}]/g, '\\$&'); // Escape special characters
      const regex = new RegExp(`(${escapedQuery})`, 'gi'); // Case-insensitive match
      const parts = title.split(regex); // Split by query matches

      // Map parts into objects with `text` and `isMatch` to control formatting
      return parts.map((part) => ({
        text: part,
        isMatch: part.toLowerCase() === this.query.toLowerCase(),
      }));
    },
    highlightQuery(title) {
      // Escape special characters in the query to safely use in regex
      const escapedQuery = this.query.replace(/[-/\\^$*+?.()|[\]{}]/g, '\\$&');
      const regex = new RegExp(`(${escapedQuery})`, 'gi'); // Case-insensitive match
      // Replace matched query with bold tags
      return title.replace(regex, '<b>$1</b>');
    },
    changeQuery(query) {

      this.$router
        .replace({
          query: Object.assign({}, this.$route.query, { query }, { page: 1 }),
        })
        .catch((error) => {
          console.error(error);
        });
      this.setQuery(query);
    },
    handleSuggestionSelection(suggestion) {
      /* eslint-disable no-underscore-dangle */
      this.$router
        .push({
          path:
            this.$route.path.slice(-1) === "/"
              ? `${this.$route.path}${suggestion.idName}`
              : `${this.$route.path}/${suggestion.idName}`,
        })
        .catch((error) => {
          console.error(error);
        });
    },
    initSort() {
      let sort = this.$route.query.sort;
      if (sort) {
        sort = sort.split(",")[0].toLowerCase();
        if (sort.includes("title")) {
          if (sort.includes("desc")) {
            this.sortSelectedLabel = this.$t("message.sort.nameZA");
            this.setSortMethod(
              `title.${this.$route.query.locale}`,
              "desc",
              this.$t("message.sort.nameZA")
            );
          } else {
            this.sortSelectedLabel = this.$t("message.sort.nameAZ");
            this.setSortMethod(
              `title.${this.$route.query.locale}`,
              "asc",
              this.$t("message.sort.nameAZ")
            );
          }
        } else {
          if (sort === "relevance+desc") {
            this.sortSelectedLabel = this.$t("message.sort.relevance");
            this.setSortMethod(
              "relevance",
              "desc",
              this.$t("message.sort.relevance")
            );
          }
          if (sort === "modified+desc") {
            this.sortSelectedLabel = this.$t("message.sort.lastUpdated");
            this.setSortMethod(
              "modified",
              "desc",
              this.$t("message.sort.lastUpdated")
            );
          }
          if (sort === "issued+desc") {
            this.sortSelectedLabel = this.$t("message.sort.lastCreated");
            this.setSortMethod(
              "issued",
              "desc",
              this.$t("message.sort.lastCreated")
            );
          }
        }
      } else
        this.setSort(
          `relevance+desc, modified+desc, title.${this.$route.query.locale}+asc`
        );
    },
    setSortMethod(method, order, label) {
      this.sortSelectedLabel = label;
      if (method === "relevance")
        this.sortSelected = `${method}+${order}, modified+desc, title.${this.$route.query.locale}+asc`;
      if (method === "modified")
        this.sortSelected = `${method}+${order}, relevance+desc, title.${this.$route.query.locale}+asc`;
      if (method === `title.${this.$route.query.locale}`)
        this.sortSelected = `${method}+${order}, relevance+desc, modified+desc`;
      if (method === "issued")
        this.sortSelected = `${method}+${order}, relevance+desc, title.${this.$route.query.locale}+asc`;
      return this.sortSelected;
    },
    isSortSelectedLabelActive(label) {
      if (label === this.sortSelectedLabel) return true;
      return false;
    },
    isSortSelectedLabelInDropdown() {
      if (
        this.sortSelectedLabel === this.$t("message.sort.nameAZ") ||
        this.sortSelectedLabel === this.$t("message.sort.nameZA") ||
        this.sortSelectedLabel === this.$t("message.sort.lastCreated") ||
        this.sortSelectedLabel === this.$t("message.sort.relevance") ||
        this.sortSelectedLabel === this.$t("message.sort.lastUpdated")
      ) {
        return true;
      }
      return false;
    },
    catalogueRouteQuery() {
      if (this.$route.query.superCatalog === 'erpd') {
        return { superCatalog: 'erpd', locale: this.$route.query.locale }
      } else if (this.$route.path.endsWith('catalogues/erpd')) {
        return { superCatalog: 'erpd', showsubcatalogs: true, locale: this.$route.query.locale }
      } else {
        return { locale: this.$route.query.locale };
      }
    },
    openApiRequest() {
      this.Url = window.location.search;
      this.UrlQuery = this.$route.query;

      // encode the filters object
      this.encodedFacets = encodeURIComponent(JSON.stringify(this.getFacets));

      // Replace specific characters for readability
      this.readableFacets = this.encodedFacets
        .replace(/%3A/g, ':')    // Replace '%3A' with ':'
        .replace(/%5B/g, '[')    // Replace '%5B' with '['
        .replace(/%5D/g, ']')    // Replace '%5D' with ']'
        .replace(/%2C/g, ',');   // Replace '%2C' with ','

      // Open in the API request in new Tab
      if (this.query) {
        window.open(this.baseUrl + "search?q=" + this.UrlQuery.query + "&filter=" + this.scope + "&includes=" + this.includes +
          "&facets=" + this.readableFacets, "_blank");
      } else {
        window.open(this.baseUrl + "search?q=" + "&filter=" + this.scope + "&includes=" + this.includes +
          "&facets=" + this.readableFacets, "_blank");
      }

    }
    // autocomplete(query) {
    //   this.autocompleteQuery(query)
    //     .then((response) => {
    //       this.autocompleteData.suggestions = [];
    //       const suggestions = response.data.result;
    //       const displayedSuggestions = [];
    //       for (const ds of suggestions.results) {
    //         displayedSuggestions.push(ds);
    //       }
    //       this.autocompleteData.suggestions = displayedSuggestions;
    //       this.autocompleteData.show = query.length !== 0;
    //     })
    //     .catch(() => {});
    // }
  },
  watch: {
    sortSelected: {
      handler(sort) {
        this.$router
          .replace({ query: Object.assign({}, this.$route.query, { sort }) })
          .catch((error) => {
            console.error(error);
          });
        this.setSort(sort);
      },
      deep: true,
    },
  },
  created() {

    this.initQuery();
    this.$nextTick(() => {
      this.initSort();
    });
  },
  setup() {

    const dropdownSuggestions = ref('dropdownSuggestions');

    var showSuggestions = reactive({
      active: false,
    })
    onClickOutside(dropdownSuggestions, event => {
      showSuggestions.active = false;

    })
    return {
      showSuggestions,
      onClickOutside,
    };
  }
};
</script>

<style lang="scss" scoped>

// Advanced search styles
.advanced-btn {
  font-weight: 400;
  height: 48px;
}

.advanced-btn:hover {
  background-color: #3e6cd5 !important;
}

.advanced-btn svg {
  margin-right: 5px;
  vertical-align: text-top;
}

.advanced-badge {
  position: absolute;
  background-color: #fff;
  color: #0e47cb;
  margin-top: -8px;
  margin-left: 6px;
}

.advanced-btn-container {
position: relative;
}


// Autocomplete styles

.auto-title {
  color: #404040;
}

.auto-thumbnail {
  background-color: #F7F7F7;
  border-radius: 4px;
  max-height: 50px;
  margin-left: 15px
}
.auto-thumbnail svg {
 top: 35%;
 position: absolute;
}
.auto-type {
  font-size: 14px;
  color: #949494;
}

.form-control {
  position: relative;
  border-right: none !important;
  border: none;
  padding: 0;

  .tooltip-icon {
    font-size: 15px;
    position: absolute;
    right: 25px;
    z-index: 2;
    top: 14px;
  }

  .suggestedTitlesWrapper {
    position: absolute;
    z-index: 99;
    background-color: white;
    padding: 0;
    width: 100%;
    border-right: 1px solid #404040;
    border-left: 1px solid #404040;
    border-bottom: 1px solid #404040;


    li {
      padding: 0.7rem;
      list-style: none;
      cursor: pointer;
      transition: margin 100ms ease-in-out;

      &:hover {
        color: #0e47cb;
        margin-left: 0.1rem;
        background-color: #f5f5f5;
      }
    }
  }

  input {
    display: block;
    width: 100%;
    height: 100%;
    margin: 0 !important;
    padding: .375rem .75rem;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    background-color: #fff;
    background-clip: padding-box;
    border: 1px solid #404040;
    border-radius: 0.25rem;
    border-top-right-radius: 0.1rem;
    border-bottom-right-radius: 0.1rem;

    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out !important;

    &:focus {
      // border: 3px solid red;
      border-color: #4A82FA;
    }
  }
}


.router-link-active {
  color: #7f7f7f !important;
  border: none !important;
  border-bottom: 2px solid #0e47cb !important;

  &:hover {
    color: #0e47cb !important;
  }
}

.loadingField:nth-child(odd) {

  overflow: hidden;
  animation: slide 1s infinite;
  background-image: linear-gradient(to right, #cecece, transparent);
  background-size: 200% 100%;

  &:hover {
    margin: 0 !important;
  }
}

@keyframes slide {
  0% {
    background-position: 0%;
  }

  50% {
    background-position: 100%;
  }

  100% {
    background-position: 0%;
  }
}

.loadingField {
  color: rgba(0, 0, 0, 0.0);

  &:hover {
    color: rgba(0, 0, 0, 0.0) !important;
  }
}

.active {
  &:hover {
    color: #fff !important;
  }
}

.router-link-inactive {
  color: rgba(0, 0, 0, 0.7);
  border: none !important;

  &:hover {
    color: #0e47cb !important;
  }
}

.ec-ds-dropdown-items .nav-item .router-link-inactive.active {
  background-color: #fff !important;
  color: #7f7f7f !important;

  &:hover {
    color: #0e47cb !important;
  }
}

.ec-ds-dropdown-items .nav-item .router-link-active {
  background-color: #0e47cb !important;
  color: #fff !important;
}


.router-link-inactive.active {
  color: #fff !important;

  &:hover {
    color: #fff !important;
  }
}

.suggestion-list-group {
  position: relative;
  width: 100%;
}

.suggestion-list {
  width: 100%;
  position: absolute;
  top: 0;
  z-index: 100;
}

.dropdown-item {
  &:active {
    background-color: var(--dropdown-item-active-bg);
  }
}

.material-icons.small-icon {
  font-size: 20px;
}

.border-radius-start {
  border-top-left-radius: 1.875rem;
  border-bottom-left-radius: 1.875rem;
}

.border-radius-end {
  border-top-right-radius: 1.875rem;
  border-bottom-right-radius: 1.875rem;
}

.inactive-styles {
  color: rgba(0, 0, 0, 0.7);

  &:hover {
    background-color: rgb(247, 247, 247);
    color: black;
  }

  &:focus {
    background-color: rgb(247, 247, 247);
    color: black;
  }
}

.custom-dropdown-button {
  border: 1px solid black;
  padding: 0;
  background-color: white;
  outline: none;
}

.cursor-pointer {
  cursor: pointer;
}

.button-color-grey {
  background-color: rgba(0, 29, 133, 0.1) !important;
  color: black !important;
}

.custom-button {
  border: 1px solid black;
  background-color: white;
  outline: none;
}

.custom-middle-button {
  border: 1px solid black;
  border-left: none;
  background-color: white;
  outline: none;
}

.search-button {
  border-radius: 100% !important;

  &:hover {
    background-color: #196fd2;
    border-color: #196fd2;
  }
}

.api-custom {
  margin-top: 32px !important;
  border: none;
  background: none;
  padding: 0px;
}

@media screen and (max-width: 767.5px) {

  .form-control {
    border: none;

    input {
      border: 1px solid #4A82FA !important;
    }
  }

  .ec-ds-dropdown-items {
    width: 100% !important;
  }

  #btnGroupDrop1 {
    justify-content: unset !important;
    border: none !important;
  }

  .colorPrimary {
    color: var(--primary)
  }

  .margin-0-mobile {
    margin: 0;
  }

  .ec-ds-search-button-container {
    margin-left: 0;
  }

  .ec-ds-scope-dropdown {
    width: 100%;
  }

  .blueBG-mobile {
    background-color: #F2F5F9;
    padding: 15px !important;
    margin: 0 -15px 0 -15px !important;
  }

  .ds-result-headline {
    margin-left: 0;
    margin-top: 20px;
  }

  .padding-0-mobile {
    padding: 0;
  }

}
</style>
